#import <iostream>
#import <cstdio>
#import <string>
#import <stdlib.h>
#include <fstream>
#import <boost/numeric/ublas/matrix.hpp>  //path to boost headers 
#import <boost/numeric/ublas/io.hpp>
#import "chrono.cpp"
#import  "matricenaive.h"
#define BOOST_UBLAS_NDEBUG 1
#define NDEBUG 1

//massively slimed down version of the code

using namespace boost::numeric::ublas;
int main (int argc, char * const argv[]) {
	
	std::ofstream fileoutput;
	fileoutput.open ("benchmark.txt", std::ios::app); 
	int rows1, col1, rows2, col2;  //matrix size can be changed here
	rows1 = 600;
	col1 = 30;
	rows2 = col1;
	col2 = 500;
	int nombremult = 10;
	
	fileoutput << rows1 <<  "	" << col1 << "	" << rows2 << "	" << col2 << "	" << nombremult << "	";
	
	
	Chrono chrono; 
	Matricenaive o(rows1,col1); 
	Matricenaive f(rows2,col2);  
	Matricenaive r;  //matrice résultat
	o.fillrandom();
	f.fillrandom();

	
	try {
		chrono.begin();
		for(int i=0; i<nombremult; i++) 
			o.times(&f,&r);
	

		}
	catch (int e) {
		fileoutput << "ERROR" << std::endl;
		return 0;
	}
	
	if(chrono.elapsed()<1000)
	fileoutput << chrono.elapsed() <<  "	" << chrono.elapsed_micro() << "	";
	else
	fileoutput << chrono.elapsed() <<  "	" << 0 << "	";
	
	
	try {
		chrono.begin();
		for(int i=0; i<nombremult; i++) 
			o.times_threaded_2(&f,&r);
		
		
	}
	catch (int e) {
				fileoutput << "ERROR" << std::endl;
		return 0;
	}
	if(chrono.elapsed()<1000)
		fileoutput << chrono.elapsed() <<  "	" << chrono.elapsed_micro() << "	";
	else
		fileoutput << chrono.elapsed() <<  "	" << 0 << "	";
	
	
	
	
	
	matrix<int> m(rows1,col1);  
	matrix<int> n(rows2,col2);
	if (col1 == rows2)
	{
	
	for(int i=0; i<rows1;i++)
		for(int j = 0; j < col1; j++)
		{
	m(i,j) = o.contenu[i][j];
		}
		
		for(int i=0; i<rows2;i++)
			for(int j = 0; j < col2; j++)
			{
				n(i,j) = f.contenu[i][j];
			}
			
	matrix<int> res;
	
	chrono.begin();
	for(int i=0; i<nombremult; i++)
	res = prod(m,n);
	
		if(chrono.elapsed()<1000)
			fileoutput << chrono.elapsed() <<  "	" << chrono.elapsed_micro() << "	";
		else
			fileoutput << chrono.elapsed() <<  "	" << 0 << "	";
		
	}
	else 
			fileoutput << "ERROR" << std::endl;
	
	
	
	
	fileoutput << std::endl ;
	fileoutput.close();
	return 0;
}
